Index: src/bin/pg_dump/pg_backup_archiver.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/bin/pg_dump/pg_backup_archiver.c,v
retrieving revision 1.124
diff -c -r1.124 pg_backup_archiver.c
*** src/bin/pg_dump/pg_backup_archiver.c	13 Feb 2006 21:30:19 -0000	1.124
--- src/bin/pg_dump/pg_backup_archiver.c	14 Feb 2006 22:48:03 -0000
***************
*** 214,220 ****
  		dumpTimestamp(AH, "Started on", AH->createDate);
  
  	if (ropt->single_txn)
! 		ahprintf(AH, "BEGIN;\n\n");
  
  	/*
  	 * Establish important parameter values right away.
--- 214,225 ----
  		dumpTimestamp(AH, "Started on", AH->createDate);
  
  	if (ropt->single_txn)
!     {
!     	if (AH->connection)
!             StartTransaction(AH);
!     	else
!     		ahprintf(AH, "BEGIN;\n\n");
!     }
  
  	/*
  	 * Establish important parameter values right away.
***************
*** 377,383 ****
  	}
  
  	if (ropt->single_txn)
! 		ahprintf(AH, "COMMIT;\n\n");
  
  	if (AH->public.verbose)
  		dumpTimestamp(AH, "Completed on", time(NULL));
--- 382,393 ----
  	}
  
  	if (ropt->single_txn)
!     {
!     	if (AH->connection)
!     		CommitTransaction(AH);
!     	else
!     		ahprintf(AH, "COMMIT;\n\n");
!     }
  
  	if (AH->public.verbose)
  		dumpTimestamp(AH, "Completed on", time(NULL));
***************
*** 652,661 ****
  void
  StartRestoreBlobs(ArchiveHandle *AH)
  {
! 	if (AH->connection)
! 		StartTransaction(AH);
! 	else
! 		ahprintf(AH, "BEGIN;\n\n");
  
  	AH->blobCount = 0;
  }
--- 662,674 ----
  void
  StartRestoreBlobs(ArchiveHandle *AH)
  {
! 	if (!AH->ropt->single_txn)
!     {
!     	if (AH->connection)
!             StartTransaction(AH);
!     	else
!     		ahprintf(AH, "BEGIN;\n\n");
!     }
  
  	AH->blobCount = 0;
  }
***************
*** 666,675 ****
  void
  EndRestoreBlobs(ArchiveHandle *AH)
  {
! 	if (AH->connection)
! 		CommitTransaction(AH);
! 	else
! 		ahprintf(AH, "COMMIT;\n\n");
  
  	ahlog(AH, 1, "restored %d large objects\n", AH->blobCount);
  }
--- 679,691 ----
  void
  EndRestoreBlobs(ArchiveHandle *AH)
  {
! 	if (!AH->ropt->single_txn)
!     {
!     	if (AH->connection)
!     		CommitTransaction(AH);
!     	else
!     		ahprintf(AH, "COMMIT;\n\n");
!     }
  
  	ahlog(AH, 1, "restored %d large objects\n", AH->blobCount);
  }
